package net.woodyfolsom.msproj.policy;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import net.woodyfolsom.msproj.GameBoard;
import net.woodyfolsom.msproj.GameConfig;
import net.woodyfolsom.msproj.GameState;
import net.woodyfolsom.msproj.policy.Policy;
import net.woodyfolsom.msproj.policy.RandomMovePolicy;

import org.junit.Test;


public class RandomTest {
	
	@Test
	public void testGenmove() {
		Policy moveGenerator = new RandomMovePolicy();
		GameState gameState = new GameState(5);
		moveGenerator.getAction(new GameConfig(), gameState, "b");
		gameState = new GameState(5);
		moveGenerator.getAction(new GameConfig(), gameState, "w");
		
		assertEquals(Policy.PASS,moveGenerator.getAction(new GameConfig(), gameState, "?"));
		
		System.out.println(gameState);
	}
	
	@Test
	public void testAlternativeToIllegalMove() {
		GameState gameState = new GameState(4);
		gameState.playStone('A', 1, GameBoard.BLACK_STONE);
		gameState.playStone('A', 2, GameBoard.BLACK_STONE);
		gameState.playStone('A', 3, GameBoard.BLACK_STONE);
		gameState.playStone('A', 4, GameBoard.BLACK_STONE);
		gameState.playStone('B', 1, GameBoard.BLACK_STONE);
		gameState.playStone('B', 2, GameBoard.BLACK_STONE);
		//gameState.playStone('B', 3, GameBoard.BLACK_STONE);
		gameState.playStone('B', 4, GameBoard.BLACK_STONE);
		gameState.playStone('C', 2, GameBoard.BLACK_STONE);
		gameState.playStone('C', 3, GameBoard.BLACK_STONE);
		gameState.playStone('C', 4, GameBoard.BLACK_STONE);
		gameState.playStone('D', 4, GameBoard.BLACK_STONE);
		assertTrue(gameState.playStone('C', 1, GameBoard.WHITE_STONE));
		assertTrue(gameState.playStone('D', 2, GameBoard.WHITE_STONE));
		assertTrue(gameState.playStone('D', 3, GameBoard.WHITE_STONE));
		System.out.println(gameState);
		//This is correct - checked vs. MFOG
		assertEquals("B3", new RandomMovePolicy().getAction(new GameConfig(), gameState, "w"));
		System.out.println(gameState);
	}
}
